﻿using C1.WPF.Grid;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace FlexGridRowHeader
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ObservableCollection<Product> Products;
        public MainWindow()
        {
            InitializeComponent();
            Products = new ObservableCollection<Product>();
            var rnd = new Random();
            for (int i = 0; i < 10; i++)
                Products.Add(new Product() { Name = "Product " + i, Stock =rnd.Next(10,50)});
            grid.ItemsSource = Products;
            grid.CellFactory = new CustomCellFactory();
        }

        class Product
        {
            public string Name { get; set; }
            public int Stock { get; set; }
        }
    }

    class CustomCellFactory : GridCellFactory
    {
        public override void BindCellContent(GridCellType cellType, GridCellRange range, FrameworkElement cellContent)
        {
            base.BindCellContent(cellType, range, cellContent);
            // Row-Header cell
            if (cellType == GridCellType.RowHeader)
            {
                if (cellContent is TextBlock txt)
                {
                    txt.Text = range.Row.ToString();
                }
            }
            // Top-Left cell
            if (cellType == GridCellType.TopLeft)
            {
                if (cellContent is TextBlock txt)
                {
                    txt.Text = "0,0";
                }
            }
        }
    }
}
